///////////////////////////////////////////////////////////////////////////////
// Wonderswan emulator
////////////////////////////////////////////////////////////////////////////////
//
// 13.04.2002: Fixed a small bug causing crashes
//
//
//
//
//////////////////////////////////////////////////////////////////////////////

#if 0
#include <windows.h>
#include <commctrl.h>

#include <direct.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <io.h>
#include <fcntl.h> 
#include <conio.h>
#include <time.h>
#include "resource.h"
#include "./source/sdl/include/sdl.h"
#include "./source/sdl/include/sdlptc.h"
#include "./source/log.h"
#else
#include "windows.h"
#include <time.h>
#include "syscall.h"
#include "pg.h"
#include "define.h"
#endif
#include "./source/rom.h"
#include "./source/nec/nec.h"
#include "./source/memory.h"
#include "./source/gpu.h"
#include "./source/io.h"
#include "./source/ws.h"
#include "./source/ticker.h"
#include "./source/2xSaI.h"

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#define		LOG_PATH "wswan.log"

#define		KEY_ENTER	0x0D
#define		KEY_SPACE	0x20
#define		KEY_ESC		0x1b
#define		KEY_UP		0x26
#define		KEY_DOWN	0x28
#define		KEY_LEFT	0x25
#define		KEY_RIGHT	0x27
#define		KEY_BUTTON1 0x57
#define		KEY_BUTTON2 0x58

#define		GUI_COMMAND_NONE				0
#define		GUI_COMMAND_RESET				1
#define		GUI_COMMAND_SCHEME_CHANGE		2
#define		GUI_COMMAND_FILTER_CHANGE		3

char		*app_window_title="Oswan 0.70 - Esc to return to GUI";
int			app_gameRunning=0;
int			app_terminate=0;
int			app_fullscreen=0;
#if 0
SDL_Event	app_input_event;
#endif
int			app_rotated=0;

int			gui_command=GUI_COMMAND_NONE;
int			gui_mainDialogRunning;
int			gui_controls_configuration_Running;
int			gui_get_key_Running;
int			gui_get_key_key;
HINSTANCE	gui_hInstance;
#if 0
SDL_Joystick *joystick=NULL;
#endif

int			ws_videoEnhancementType=0;
int			ws_colourScheme=COLOUR_SCHEME_DEFAULT;
int			ws_system=WS_SYSTEM_AUTODETECT;
#if 0
char		*ws_rom_path;
char		old_rom_path[4096];
#else
char		ws_rom_path[MAX_PATH];
char		old_rom_path[MAX_PATH];
char		ws_app_path[MAX_PATH];
char		ws_rom_name[MAX_NAME];
char		ws_save_path[MAX_PATH];
ctrl_data_t	paddata;
#endif

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
char *gui_getRomPath(HWND hWnd)
{
#if 0
	static OPENFILENAME ofn;				// common dialog box structure
	static char			szFile[260];		// buffer for file name
	HWND				hwnd;				// owner window
	HANDLE				hf;					// file handle
	static char			oldDir[1024];

	InitCommonControls();
	_getcwd(oldDir,1024);
	szFile[0]=0;
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "Wonderswan mono\0*.ws\0Wonderswan color\0*.wsc\0\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	ofn.hInstance=NULL;
	// Display the Open dialog box. 

	if (GetOpenFileName(&ofn)==TRUE)
		return(ofn.lpstrFile);
	chdir(oldDir);
#endif
	return(NULL);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
char *gui_loadState(HWND hWnd)
{
#if 0
	static OPENFILENAME ofn;				// common dialog box structure
	static char			szFile[260];		// buffer for file name
	HWND				hwnd;				// owner window
	HANDLE				hf;					// file handle
	static char			oldDir[1024];

	InitCommonControls();
	_getcwd(oldDir,1024);
	szFile[0]=0;
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "Wonderswan state\0*.wss\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	ofn.hInstance=NULL;
	// Display the Open dialog box. 

	if (GetOpenFileName(&ofn)==TRUE)
		return(ofn.lpstrFile);
	chdir(oldDir);
#endif
	return(NULL);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
char *gui_saveState(HWND hWnd)
{
#if 0
	static OPENFILENAME ofn;				// common dialog box structure
	static char			szFile[260];		// buffer for file name
	HWND				hwnd;				// owner window
	HANDLE				hf;					// file handle
	static char			oldDir[1024];

	InitCommonControls();
	_getcwd(oldDir,1024);
	szFile[0]=0;
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "Wonderswan state\0*.wss\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = 0;
	ofn.hInstance=NULL;
	// Display the Open dialog box. 

	if (GetSaveFileName(&ofn)==TRUE)
		return(ofn.lpstrFile);
	chdir(oldDir);
#endif
	return(NULL);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK GuiMainDialogProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
#if 0
	static BOOL bButton = FALSE;


	switch(message)
	{
		case WM_INITDIALOG:
			break;
		
		case WM_CLOSE:
		{
			gui_mainDialogRunning=0;
			DestroyWindow(hWnd);
			return 1;
		}
		case WM_COMMAND:
		{
			
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_LOAD))
			{
					ws_rom_path=gui_getRomPath(hWnd);
					if (ws_rom_path)
						SendMessage(hWnd, WM_CLOSE, 0,0);
					return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_SAVESTATE))
			{
				char *path=gui_saveState(hWnd);
				if (path)
				{
					int err=ws_saveState(path);
					if (err==0)
						MessageBox(hWnd,"State cannot be saved","Error",MB_OK);
					else
						SendMessage(hWnd, WM_CLOSE, 0,0);
				}
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_LOADSTATE))
			{
				char *path=gui_loadState(hWnd);
				if (path)
				{
					int err=ws_loadState(path);
					if (err==0)
						MessageBox(hWnd,"State cannot be loaded","Error",MB_OK);
					else
					if (err==-1)
						MessageBox(hWnd,"Please load the correct rom first","Error",MB_OK);
					else
						SendMessage(hWnd, WM_CLOSE, 0,0);
				}
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_RESET))
			{
					gui_command=GUI_COMMAND_RESET;
					SendMessage(hWnd, WM_CLOSE, 0,0);
					return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_CONTINUE))
			{
				SendMessage(hWnd, WM_CLOSE, 0,0);
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_BUTTON_EXIT))
			{
				SendMessage(hWnd, WM_CLOSE, 0,0);
				app_terminate=1;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_STANDARD_MODE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_STANDARD_MODE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=0;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_DOUBLESIZE_MODE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_DOUBLESIZE_MODE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=1;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SCANLINES_MODE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SCANLINES_MODE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=2;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_50PRCTSCANLINES_MODE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_50PRCTSCANLINES_MODE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=3;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SPECIAL_MODE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SPECIAL_MODE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=4;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_2XSAI))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_2XSAI),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=5;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SUPER2XSAI))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SUPER2XSAI),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=6;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SUPEREAGLE))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SUPEREAGLE),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_videoEnhancementType=7;
				gui_command=GUI_COMMAND_FILTER_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_FULLSCREEN))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_FULLSCREEN),BM_GETCHECK ,0,0)==BST_CHECKED)
					app_fullscreen=1;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_WINDOWED))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_WINDOWED),BM_GETCHECK ,0,0)==BST_CHECKED)
					app_fullscreen=0;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_COLOUR_DEFAULT))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_COLOUR_DEFAULT),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_colourScheme=COLOUR_SCHEME_DEFAULT;
				gui_command=GUI_COMMAND_SCHEME_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_COLOUR_AMBER))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_COLOUR_AMBER),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_colourScheme=COLOUR_SCHEME_AMBER;
				gui_command=GUI_COMMAND_SCHEME_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_COLOUR_GREEN))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_COLOUR_GREEN),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_colourScheme=COLOUR_SCHEME_GREEN;
				gui_command=GUI_COMMAND_SCHEME_CHANGE;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SYSTEM_AUTODETECT))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SYSTEM_AUTODETECT),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_system=WS_SYSTEM_AUTODETECT;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SYSTEM_COLOR))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SYSTEM_COLOR),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_system=WS_SYSTEM_COLOR;
				return 1;
			}
			if ((HIWORD(wParam)==BN_CLICKED)&&(LOWORD(wParam)==IDC_RADIO_SYSTEM_MONO))
			{	
				if (SendMessage(GetDlgItem(hWnd, IDC_RADIO_SYSTEM_MONO),BM_GETCHECK ,0,0)==BST_CHECKED)
					ws_system=WS_SYSTEM_MONO;
				return 1;
			}
		}
	}
	if(message == WM_INITDIALOG)
		return(TRUE);
#endif
	return (FALSE);
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
void gui_open(void)
{
#if 0
	HWND	hwnd, hCtrl;
	MSG		msg;

	gui_command=GUI_COMMAND_NONE;
	InitCommonControls();
	ws_rom_path=NULL;
	hwnd		= CreateDialog(gui_hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)GuiMainDialogProc);

	if (hwnd==NULL)
	{
		MessageBox(NULL,"Cannot create gui","Error",MB_OK);
		return;
	}
	if (ws_colourScheme==COLOUR_SCHEME_DEFAULT)
		SendMessage(GetDlgItem(hwnd, IDC_COLOUR_DEFAULT),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_colourScheme==COLOUR_SCHEME_AMBER)
		SendMessage(GetDlgItem(hwnd, IDC_COLOUR_AMBER),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_colourScheme==COLOUR_SCHEME_GREEN)
		SendMessage(GetDlgItem(hwnd, IDC_COLOUR_GREEN),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);

	if (ws_videoEnhancementType==0)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_STANDARD_MODE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==1)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_DOUBLESIZE_MODE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==2)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SCANLINES_MODE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==3)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_50PRCTSCANLINES_MODE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==4)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SPECIAL_MODE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==5)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_2XSAI),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==6)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SUPER2XSAI),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_videoEnhancementType==7)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SUPEREAGLE),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);

	if (app_fullscreen)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_FULLSCREEN),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_WINDOWED),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);

	if (ws_system==WS_SYSTEM_AUTODETECT)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SYSTEM_AUTODETECT),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_system==WS_SYSTEM_COLOR)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SYSTEM_COLOR),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);
	else
	if (ws_system==WS_SYSTEM_MONO)
		SendMessage(GetDlgItem(hwnd, IDC_RADIO_SYSTEM_MONO),BM_SETCHECK ,(WPARAM)BST_CHECKED,0);

	gui_mainDialogRunning=1;
	ShowWindow(hwnd, SW_SHOWDEFAULT);
	UpdateWindow(hwnd);

	while(gui_mainDialogRunning)
	{
		if (GetMessage(&msg, hwnd, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	DestroyWindow(hwnd);
#endif
}
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#if 0
#include "./source/filters/standard.h"
#include "./source/filters/doubled.h"
#include "./source/filters/scanlines.h"
#include "./source/filters/halfscanlines.h"
#include "./source/filters/2xsai.h"
#include "./source/filters/super2xsai.h"
#include "./source/filters/supereagle.h"
#include "./source/filters/special.h"
#endif
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#if 1

int bSleep=0;

int exit_callback(void) 
{ 

	// Cleanup the games resources etc (if required) 
	ws_saveState(ws_save_path);

	// Exit game 
	sceKernelExitGame(); 

	return 0;
}

void power_callback(int unknown, int pwrflags)
{
	int cbid;
	char *p;

	// Combine pwrflags and the above defined masks
	if(pwrflags & POWER_CB_POWER){
		bSleep=1;
		ws_saveState(ws_save_path);
	}
	
	// R[obN֐̍ēo^
	cbid = sceKernelCreateCallback("Power Callback", power_callback);
	PowerSetCallback(0, cbid);
}

// Thread to create the callbacks and then begin polling
int CallbackThread(int args, void *argp)
{
	int cbid;
	
	cbid = sceKernelCreateCallback("Exit Callback", exit_callback);
	SetExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", power_callback);
	PowerSetCallback(0, cbid);
	
	// |[O
	KernelPollCallbacks();
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
#endif


////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#if 0
int WINAPI WinMain( HINSTANCE hInstance,    // handle to current instance 
                    HINSTANCE hPrevInstance,// handle to previous instance 
                    LPSTR     lpCmdLine,    // pointer to command line 
                    int       nCmdShow )    // show state of window 
{
	if (!log_init(LOG_PATH)) printf("Warning: cannot open log file %s\n",LOG_PATH);
 	fprintf(log_get(),"Wonderswan emulator v0.70 (last build on %s %s)\n",__DATE__,__TIME__);
	ws_videoEnhancementType=0;
	Init_2xSaI(555);
	gui_hInstance=hInstance;
	gui_open();
	while (!app_terminate)
	{
		if (!ws_rom_path)
		{
			app_gameRunning=0;
			gui_open();
		}
		if (ws_rom_path)
		{
			if (ws_init(ws_rom_path))
			{
				app_rotated=ws_rotated();
				app_gameRunning=1;
				ws_set_system(ws_system);
				ws_set_colour_scheme(ws_colourScheme);
				ws_buildHalfBrightnessTable();
				ws_reset();
				switch (ws_videoEnhancementType)
				{
				case 0: ws_emulate_standard(); break;
				case 1: ws_emulate_doubled(); break;
				case 2: ws_emulate_scanlines(); break;
				case 3: ws_emulate_halfBrightnessScanlines(); break;
				case 4: ws_emulate_special(); break;
				case 5: ws_emulate_2xSaI(); break;
				case 6: ws_emulate_Super2xSaI(); break;
				case 7: ws_emulate_SuperEagle(); break;
				}
			}
			ws_done();
		}
	}
	log_done();
	return(0);
}
#else

// -----------------------------------------------------------------------------"source/filters/standard.h" START
signed short backbuffer[224*144*16];

void ws_rotate_backbuffer(signed short *backbuffer)
{
	static signed short temp[224*144];
	memcpy(temp,backbuffer,224*144*2);

	int line, column;
	for (line=0;line<144;line++)
		for (column=0;column<224;column++)
			backbuffer[line+((223-column)<<7)+((223-column)<<4)]=temp[column+(line<<7)+(line<<6)+(line<<5)];
}
#if 1

void renderer_update_pad()
{
	sceCtrlRead(&paddata, 1);
	ws_key_up		= 0;
	ws_key_down		= 0;
	ws_key_left		= 0;
	ws_key_right	= 0;
	ws_key_button_1	= 0;
	ws_key_button_2	= 0;
	ws_key_start	= 0;
	ws_key_menu		= 0;
	if(paddata.buttons & CTRL_DOWN)		ws_key_down		= 1;
	if(paddata.buttons & CTRL_UP)		ws_key_up		= 1;
	if(paddata.buttons & CTRL_LEFT)		ws_key_left		= 1;
	if(paddata.buttons & CTRL_RIGHT)	ws_key_right	= 1;
	if(paddata.buttons & CTRL_CIRCLE)	ws_key_button_1	= 1;
	if(paddata.buttons & CTRL_CROSS)	ws_key_button_2	= 1;
	if(paddata.buttons & CTRL_START)	ws_key_start	= 1;
	if(paddata.buttons & CTRL_RTRIGGER) ws_key_menu		= 1;

//#define TEST
#undef TEST
#ifdef TEST
	if(paddata.buttons & CTRL_LTRIGGER)
		ws_saveState(ws_save_path);
	if(paddata.buttons & CTRL_RTRIGGER)
		ws_loadState(ws_save_path);

		 if(paddata.buttons & CTRL_DOWN)		pgPrint(30,1,0xffff,"You pressed down!");
	else if(paddata.buttons & CTRL_UP)			pgPrint(30,1,0xffff,"You pressed up!");
	else if(paddata.buttons & CTRL_LEFT)		pgPrint(30,1,0xffff,"You pressed left!");
	else if(paddata.buttons & CTRL_RIGHT)		pgPrint(30,1,0xffff,"You pressed right!");
	else if(paddata.buttons & CTRL_CIRCLE)		pgPrint(30,1,0xffff,"You pressed circle!");
	else if(paddata.buttons & CTRL_CROSS)		pgPrint(30,1,0xffff,"You pressed cross!");
	else if(paddata.buttons & CTRL_TRIANGLE)	pgPrint(30,1,0xffff,"You pressed triangle!");
	else if(paddata.buttons & CTRL_SQUARE)		pgPrint(30,1,0xffff,"You pressed aquare!");
	else if(paddata.buttons & CTRL_START)		pgPrint(30,1,0xffff,"You pressed start!");
	else if(paddata.buttons & CTRL_SELECT)		pgPrint(30,1,0xffff,"You pressed select!");
	else if(paddata.buttons & CTRL_LTRIGGER)	pgPrint(30,1,0xffff,"You pressed L trigger!");
	else if(paddata.buttons & CTRL_RTRIGGER)	pgPrint(30,1,0xffff,"You pressed R trigger!");
#endif
}

void render_screen()
{
	if (app_rotated) {
		ws_rotate_backbuffer(backbuffer);
		pgBitBltN1v((SCREEN_WIDTH - 144) / 2, (SCREEN_HEIGHT - 224) / 2, (unsigned long *)backbuffer);
	} else {
		pgBitBltN1h((SCREEN_WIDTH - 224) / 2, (SCREEN_HEIGHT - 144) / 2, (unsigned long *)backbuffer);
	}
}

#endif

//#define DEBUG
#undef DEBUG
void ws_emulate_standard(void)
{
// -----------------------------------------------------------------------------"source/filters/filter_partA.h" START
	unsigned long startTime, endTime, totalFrames;
	unsigned int nNormalLast=0;
	int nNormalFrac=0;
	int nTime=0,nCount=0; int i=0;
	int surfacePitch;

#if 0
	Format format(16,0x007c00,0x00003e0,0x0000001f);
	Console console;
	Surface *surface;
#endif
// -----------------------------------------------------------------------------"source/filters/filter_partA.h" END
#if 0 // app_rotated
	if (app_rotated)
	{
		surface=new Surface(144,224,format);
		#include "filter_partB.h"
		surfacePitch>>=1;
		console.open(app_window_title,144,224,format);
		while (1)
		{
				#include "filter_partC.h"
				console.open(app_window_title,144,224,format);
				#include "filter_partD.h"
				ws_rotate_backbuffer(backbuffer);
				int32 *vs = (int32 *)surface->lock();
				memcpy(vs,backbuffer,224*144*2);				
				surface->unlock();
				surface->copy(console);
				console.update();
			}
		}
		#include "filter_partE.h"
	}
	else
	{
		surface=new Surface(224,144,format);
		#include "filter_partB.h"
		console.open(app_window_title,224,144,format);
		while (1)
		{
				#include "filter_partC.h"
				console.open(app_window_title,224,144,format);
				#include "filter_partD.h"
				int32 *vs = (int32 *)surface->lock();
				memcpy(vs,backbuffer,224*144*2);
				surface->unlock();
				surface->copy(console);
				console.update();
			}
		}
		#include "filter_partE.h"
	}
#else // ! app_rotated
#if 0
	surface=new Surface(224,144,format);
#endif
// -----------------------------------------------------------------------------"source/filters/filter_partB.h" START
//	signed short *backbuffer=backbuffer_substance;

	memset(backbuffer,0x00,224*144*sizeof(signed short));
#if 0
	surfacePitch=(surface->pitch()>>1);
	console.option("DirectX");
	if (app_fullscreen)
	        console.option("fullscreen output");
	else
	        console.option("windowed output");
	console.option("fixed window");
	console.option("center window");
#endif
	totalFrames=0;

	nNormalLast=0;
	nNormalFrac=0;

#if 0
	if (gui_command==3)
	{
		ws_loadState("oswan.wss");
	}
#else
	ws_loadState(ws_save_path);
#endif
// -----------------------------------------------------------------------------"source/filters/filter_partB.h" END
#if 0
	console.open(app_window_title,224,144,format);
#endif
#if 1
	const unsigned int sync_time=16666;
	unsigned long prev_time, cur_time, diff_time = 1000000;
	unsigned long framecount = 0;
#endif
	while (1) // -----------------------------------------------------------------------------------------------------------------------------
	{
		pgFillvram(0);
// -----------------------------------------------------------------------------"source/filters/filter_partC.h" START
#if 0
		nTime=timeGetTime()-nNormalLast;
#else
		nTime = sceKernelLibcClock()/1000 - nNormalLast;

#ifdef DEBUG
		framecount++;
		if (framecount >= 60) {
			cur_time = sceKernelLibcClock();
			framecount = 0;
			diff_time = cur_time - prev_time;
			prev_time = cur_time;
		}
char buf[128];
sprintf(buf, "%d", diff_time/1000000*60);
pgDebug(buf, 0);
sprintf(buf, "%d", diff_time);
pgDebug(buf, 1);
#endif

#endif
		nCount=(nTime*600 - nNormalFrac) /10000;
#ifdef DEBUG
sprintf(buf, "%d", nCount);
pgDebug(buf, 2);
#endif
#if 0
		if (nCount<=0)
		{
			pgWaitVn(2);
		}
		else
		{
#endif
			nNormalFrac+=nCount*10000;
			nNormalLast+=nNormalFrac/600;
			nNormalFrac%=600;

#define TEST
//#undef  TEST
#ifndef TEST
			if (nCount>10)
				nCount=10;
#else
			if (nCount>5)
				nCount=5;
#endif
#undef  TEST

			int ws_key_esc=0;

// -----------------------------------------------------------------------------"source/temp/key.h" START
#if 0
			static testJoystick=1;
			if (testJoystick==1)
			{
				testJoystick=0;
				fprintf(log_get(),"%i joysticks were found.\n\n", SDL_NumJoysticks() );
				fprintf(log_get(),"The names of the joysticks are:\n");
				for(int tti=0; tti < SDL_NumJoysticks(); tti++ )
					fprintf(log_get(),"    %s\n", SDL_JoystickName(tti));
				SDL_JoystickEventState(SDL_ENABLE);
				joystick = SDL_JoystickOpen(0);
			}
			else
			{
				if (joystick!=((void *)0))
				{
					SDL_JoystickClose(0);
					SDL_JoystickEventState(SDL_ENABLE);
					joystick = SDL_JoystickOpen(0);
				}
			}

			while ( SDL_PollEvent(&app_input_event) )
			{
				if ( app_input_event.type == SDL_QUIT )
				{
					ws_key_esc = 1;
				}
			}

			if (joystick)
			{
				if (SDL_JoystickGetButton(joystick,0))
					ws_key_start=1;
				else
					ws_key_start=0;
				if (SDL_JoystickGetButton(joystick,1))
					ws_key_button_1=1;
				else
					ws_key_button_1=0;
				if (SDL_JoystickGetButton(joystick,2))
					ws_key_button_2=1;
				else
					ws_key_button_2=0;

				if (SDL_JoystickGetAxis(joystick,0)<-7000)
				ws_key_left=1;
				else
				ws_key_left=0;
				if (SDL_JoystickGetAxis(joystick,0)>7000)
				ws_key_right=1;
				else
				ws_key_right=0;

				if (SDL_JoystickGetAxis(joystick,1)<-7000)
					ws_key_up=1;
				else
					ws_key_up=0;
				if (SDL_JoystickGetAxis(joystick,1)>7000)
					ws_key_down=1;
				else
					ws_key_down=0;
			}
			else
			{
				ws_key_start=0;
				ws_key_left=0;
				ws_key_right=0;
				ws_key_up=0;
				ws_key_down=0;
				ws_key_button_1=0;
				ws_key_button_2=0;
			}
			BYTE *keystate = SDL_GetKeyState(((void *)0));

			if ( keystate[SDLK_ESCAPE] )
				ws_key_esc = 1;
			if ( keystate[SDLK_UP] )
				ws_key_up=1;
			if ( keystate[SDLK_DOWN] )
				ws_key_down=1;
			if ( keystate[SDLK_RIGHT] )
				ws_key_right=1;
			if ( keystate[SDLK_LEFT] )
				ws_key_left=1;
			if (keystate[SDLK_RETURN])
				ws_key_start=1;
			if (keystate[SDLK_c])
				ws_key_button_1=1;
			if (keystate[SDLK_x])
				ws_key_button_2=1;
			if (keystate[SDLK_p])
				ws_cyclesByLine+=10;
			if (keystate[SDLK_o])
				ws_cyclesByLine-=10;
#else
			renderer_update_pad();
#endif
// -----------------------------------------------------------------------------"source/temp/key.h" END

#if 0
			// "source/filters/filter_partC.h" 2
			if (ws_key_esc)
			{
				console.close();
				if (ws_rom_path)
					strcpy(old_rom_path,ws_rom_path);
					gui_open();

				if ((ws_rom_path!=((void *)0))||(app_terminate))
					break;

				if (gui_command)
				{
					if (gui_command==1)
						ws_reset();
					if (gui_command==2)
						ws_set_colour_scheme(ws_colourScheme);
					if (gui_command==3)
					{
						ws_saveState("oswan.wss");
						ws_rom_path=old_rom_path;
						delete surface;
						strcpy(ws_rom_path, old_rom_path);
						return;
					}
				}

				console.option("DirectX");
				if (app_fullscreen)
					console.option("fullscreen output");
				else
					console.option("windowed output");
				console.option("fixed window");
				console.option("center window");
// -----------------------------------------------------------------------------"source/filters/filter_partC.h" END

				console.open(app_window_title,224,144,format);

// -----------------------------------------------------------------------------"source/filters/filter_partD.h" START
			}
#endif
			for (i=0;i<nCount-1;i++)
				while (!ws_executeLine(backbuffer,0));
				while (!ws_executeLine(backbuffer,1));
				totalFrames++;
// -----------------------------------------------------------------------------"source/filters/filter_partD.h" END
#if 0
			int32 *vs = (int32 *)surface->lock();
			memcpy(vs,backbuffer,224*144*2);
			surface->unlock();
			surface->copy(console);
			console.update();
#else
			render_screen();
#endif
#if 0
		} // end of if nCount
#endif
//pgPrint(0, 0, 0x0ff0, ws_save_path);
		pgScreenFlipV();
//		pgWaitV();

		if (ws_key_menu == 1) {
			main_menu();
			
			// 
		}


	} // end of while -----------------------------------------------------------------------------------------------------------------------
#endif // ! app_rotated
}
// -----------------------------------------------------------------------------"source/filters/standard.h" START

//#define PSPE
#undef PSPE
extern char LastPath[MAX_PATH];
int xmain(int argc, char *argv)
{
	// pgMain()
	sceDisplaySetMode(0,SCREEN_WIDTH,SCREEN_HEIGHT);
	pgScreenFrame(0,1);
	pgcLocate(0,0);
	pgcColor(0xffff,0x0000);
	pgcDraw(1,1);
	pgcSetmag(1);
	pgScreenFrame(0,0); //screen off
	pgcLocate(0,0);
	pgcColor(0xffff,0x0000);
	pgcDraw(1,1);
	pgcSetmag(1);

	// pgiInit()
//	sceCtrlInit(0);
	sceCtrlSetAnalogMode(1);

	int tid;
	tid = SetupCallbacks();
	
	// pgInit()
	sceDisplaySetMode(0,SCREEN_WIDTH,SCREEN_HEIGHT);
	pgScreenFrame(0,0); //screen off

	pgScreenFrame(2,0); //show/draw different
	sceCtrlInit(0);

	pgScreenClear();

	load_config(); // call before getFilePath()
//	load_menu_bg();

	// Load ROM
	int n;
	char *p;

#ifndef PSPE
	n = argc;
	if (n > sizeof(ws_app_path) - 1) n = sizeof(ws_app_path) - 1;
	memcpy(ws_app_path, argv, n);
	ws_app_path[sizeof(ws_app_path) - 1] = 0;
	strcpy(ws_app_path, argv);
	p = strrchr(ws_app_path, '/');
	*++p = 0;
	strcpy(LastPath, ws_app_path);
//	strcpy(ws_rom_path, ws_app_path);
//	strcat(ws_rom_path, "ROM.wsc");
	while (!getFilePath(ws_rom_path))
		;
	p = strrchr(ws_rom_path, '/');
	strcpy(ws_rom_name, ++p);
	strcpy(ws_save_path, ws_rom_path);
	p = strrchr(ws_save_path, '/');
	*++p = 0;
	strcat(ws_save_path, ws_rom_name);
	p = strrchr(ws_save_path, '.');
	*++p = 0;
	strcat(ws_save_path, "sav");

#else
	strcpy(ws_rom_path, "ROM.wsc");
#endif

//	app_terminate = 0;
	
	pgScreenClear();

//	while (!app_terminate)
//	{
		if (ws_init(ws_rom_path))
		{
			app_rotated=ws_rotated();
			app_gameRunning=1;
			ws_set_system(ws_system);
			ws_set_colour_scheme(ws_colourScheme);
//				ws_buildHalfBrightnessTable();
			ws_reset();
			
			ws_emulate_standard();
		
		}
		ws_done();
		pgWaitV();
//	} // end of while (!app_terminate)

	return(0);
}
#endif

